Loading...
Searching...
No Matches
ON_Polyline Class Reference

`#include <pcl/surface/3rdparty/opennurbs/opennurbs_polyline.h>`

Inheritance diagram for ON_Polyline:

## Public Member Functions

| ON_Polyline ()
| ON_Polyline (const ON_3dPointArray &)
ON_Polyline & | operator= (const ON_3dPointArray &)
| ~ON_Polyline ()
bool | CreateInscribedPolygon (const ON_Circle &circle, int side_count)
bool | CreateCircumscribedPolygon (const ON_Circle &circle, int side_count)
bool | CreateStarPolygon (const ON_Circle &circle, double other_radius, int side_count)
bool | IsValid (double tolerance=0.0) const
int | Clean (double tolerance=0.0)
int | PointCount () const
int | SegmentCount () const
bool | IsClosed (double tolerance=0.0) const
double | Length () const
ON_3dVector | SegmentDirection (int segment_index) const
ON_3dVector | SegmentTangent (int segment_index) const
ON_3dPoint | PointAt (double t) const
ON_3dVector | DerivativeAt (double t) const
ON_3dVector | TangentAt (double t) const
bool | ClosestPointTo (const ON_3dPoint &test_point, double *t) const
bool | ClosestPointTo (const ON_3dPoint &test_point, double *t, int segment_index0, int segment_index1) const
ON_3dPoint | ClosestPointTo (const ON_3dPoint &test_point) const
Public Member Functions inherited from ON_3dPointArray
| ON_3dPointArray ()
| ON_3dPointArray (int)
| ON_3dPointArray (const ON_SimpleArray< ON_3dPoint > &)
ON_3dPointArray & | operator= (const ON_3dPointArray &)
| ON_3dPointArray (const ON_SimpleArray< ON_3fPoint > &)
ON_3dPointArray & | operator= (const ON_SimpleArray< ON_3fPoint > &)
bool | Create (int point_dimension, int bRational, int point_count, int point_stride, const double *points)
bool | Create (int point_dimension, int bRational, int point_count, int point_stride, const float *points)
ON_BoundingBox | BoundingBox () const
bool | GetBoundingBox (ON_BoundingBox &bbox, int bGrowBox=false) const
bool | GetBBox (double boxmin[3], double boxmax[3], int bGrowBox=false) const
bool | GetTightBoundingBox (ON_BoundingBox &tight_bbox, int bGrowBox=false, const ON_Xform *xform=0) const
bool | Transform (const ON_Xform &xform)
bool | SwapCoordinates (int i, int j)
bool | Rotate (double sin_angle, double cos_angle, const ON_3dVector &axis_of_rotation, const ON_3dPoint &center_of_rotation)
bool | Rotate (double angle_in_radians, const ON_3dVector &axis_of_rotation, const ON_3dPoint &center_of_rotation)
bool | Translate (const ON_3dVector &delta)
bool | GetClosestPoint (ON_3dPoint P, int *closest_point_index, double maximum_distance=0.0) const
Public Member Functions inherited from ON_SimpleArray< ON_3dPoint >
| ON_SimpleArray ()
virtual | ~ON_SimpleArray ()
virtual ON_SimpleArray< ON_3dPoint > & | operator= (const ON_SimpleArray< ON_3dPoint > &)
void | EmergencyDestroy (void)
int | Count () const
unsigned int | UnsignedCount () const
int | Capacity () const
unsigned int | SizeOfArray () const
unsigned int | SizeOfElement () const
ON__UINT32 | DataCRC (ON__UINT32 current_remainder) const
ON_3dPoint & | operator[] (int)
| operator ON_3dPoint * ()
| operator const ON_3dPoint * () const
ON_3dPoint * | First ()
ON_3dPoint * | At (int)
ON_3dPoint * | Last ()
ON_3dPoint & | AppendNew ()
void | Append (const ON_3dPoint &)
void | Insert (int, const ON_3dPoint &)
void | Remove ()
void | Empty ()
void | Reverse ()
void | Swap (int, int)
int | Search (const ON_3dPoint &) const
int | BinarySearch (const ON_3dPoint *, int(*)(const ON_3dPoint *, const ON_3dPoint *)) const
bool | HeapSort (int(*)(const ON_3dPoint *, const ON_3dPoint *))
bool | QuickSort (int(*)(const ON_3dPoint *, const ON_3dPoint *))
bool | Sort (ON::sort_algorithm sort_algorithm, int *, int(*)(const ON_3dPoint *, const ON_3dPoint *)) const
bool | Permute (const int *)
void | Zero ()
void | MemSet (unsigned char)
void | Reserve (int)
void | Shrink ()
void | Destroy ()
virtual ON_3dPoint * | Realloc (ON_3dPoint *, int)
ON_3dPoint * | Array ()
void | SetCount (int)
void | SetCapacity (int)
int | NewCapacity () const
ON_3dPoint * | KeepArray ()
void | SetArray (ON_3dPoint *)

## Additional Inherited Members

Protected Member Functions inherited from ON_SimpleArray< ON_3dPoint >
void | Move (int, int, int)
Protected Attributes inherited from ON_SimpleArray< ON_3dPoint >
ON_3dPoint * | m_a
int | m_count
int | m_capacity

## Detailed Description

Definition at line 20 of file opennurbs_polyline.h.

## Constructor & Destructor Documentation

## ON_Polyline() [1/2]

ON_Polyline::ON_Polyline | ( |  | ) |

Referenced by operator=().

## ON_Polyline() [2/2]

ON_Polyline::ON_Polyline | ( | const ON_3dPointArray & |  | ) |

References ON_3dPointArray::ON_3dPointArray().

## ~ON_Polyline()

ON_Polyline::~ON_Polyline | ( |  | ) |

## Member Function Documentation

## Clean()

int ON_Polyline::Clean | ( | double | tolerance = 0.0 | ) |

## ClosestPointTo() [1/3]

ON_3dPoint ON_Polyline::ClosestPointTo | ( | const ON_3dPoint & | test_point | ) | const

## ClosestPointTo() [2/3]

bool ON_Polyline::ClosestPointTo | ( | const ON_3dPoint & | test_point,
|  | double * | t ) const

## ClosestPointTo() [3/3]

bool ON_Polyline::ClosestPointTo | ( | const ON_3dPoint & | test_point,
|  | double * | t,
|  | int | segment_index0,
|  | int | segment_index1 ) const

## CreateCircumscribedPolygon()

bool ON_Polyline::CreateCircumscribedPolygon | ( | const ON_Circle & | circle,
|  | int | side_count )

## CreateInscribedPolygon()

bool ON_Polyline::CreateInscribedPolygon | ( | const ON_Circle & | circle,
|  | int | side_count )

## CreateStarPolygon()

bool ON_Polyline::CreateStarPolygon | ( | const ON_Circle & | circle,
|  | double | other_radius,
|  | int | side_count )

## DerivativeAt()

ON_3dVector ON_Polyline::DerivativeAt | ( | double | t | ) | const

## IsClosed()

bool ON_Polyline::IsClosed | ( | double | tolerance = 0.0 | ) | const

## IsValid()

bool ON_Polyline::IsValid | ( | double | tolerance = 0.0 | ) | const

## Length()

double ON_Polyline::Length | ( |  | ) | const

## operator=()

ON_Polyline & ON_Polyline::operator= | ( | const ON_3dPointArray & |  | ) |

References ON_3dPointArray::ON_3dPointArray(), and ON_Polyline().

## PointAt()

ON_3dPoint ON_Polyline::PointAt | ( | double | t | ) | const

## PointCount()

int ON_Polyline::PointCount | ( |  | ) | const

## SegmentCount()

int ON_Polyline::SegmentCount | ( |  | ) | const

## SegmentDirection()

ON_3dVector ON_Polyline::SegmentDirection | ( | int | segment_index | ) | const

## SegmentTangent()

ON_3dVector ON_Polyline::SegmentTangent | ( | int | segment_index | ) | const

## TangentAt()

ON_3dVector ON_Polyline::TangentAt | ( | double | t | ) | const

The documentation for this class was generated from the following file:

- pcl/surface/3rdparty/opennurbs/opennurbs_polyline.h